<template>
  <div class="row q-mb-sm q-mt-xs">
    <div class="col-12">
      <q-btn-dropdown
        no-icon-animation
        dropdown-icon=" "
        flat color="white" dense stretch
        text-color="black" size="md"
        class="float-right on-right q-pt-xs"
        icon="la la-filter">
        <q-list class="appearingElement">
          <q-item>
            <q-item-section>
              <div class="row">
                <div class="col-10">
                  <q-item-label class="q-pt-sm">
                    <strong>Constructeur de filtre</strong>
                  </q-item-label>
                </div>
                <div class="col-2">
                  <q-btn stretch v-close-popup class="float-right" size="sm"
                         icon="la la-times" color="red"
                         dense flat/>
                </div>
              </div>
            </q-item-section>
          </q-item>

          <q-item>
            <q-item-section>
              <q-card flat class="" style="min-width: 580px !important;">
                <template v-for="(filter, key) in filters">
                  <filter-line
                    v-model="filters[key]"
                    :is-main="key === 0"
                    :key="key"
                    :fields="searcheableColumns"
                  />
                </template>
              </q-card>
            </q-item-section>
          </q-item>

          <q-item>
            <q-item-section>
              <div class="row">
                <div class="col-12">
                  <q-btn dense flat stretch
                         icon-right="la la-search"
                         class="on-right float-right"
                         size="md"
                         @click.prevent="onSearch"
                  >
                    <q-tooltip>
                      Lancer la recherche
                    </q-tooltip>
                  </q-btn>
                  <q-btn stretch
                         dense flat size="md"
                         icon-right="la la-trash" class="on-right float-right"
                         @click.prevent="onReset"
                  >
                    <q-tooltip>
                      Effacer ce filtre
                    </q-tooltip>
                  </q-btn>
                  <q-btn stretch dense flat icon-right="la la-save" class="on-right float-right" size="md">
                    <q-tooltip>
                      Enregistrer
                    </q-tooltip>
                  </q-btn>
                </div>
              </div>
            </q-item-section>
          </q-item>
        </q-list>
      </q-btn-dropdown>
      <q-select
        dense options-dense
        :readonly="false"
        :multiple="true"
        :use-input="true"
        :use-chips="true"

        v-model="search"
        :options="filteredSearchOptions"
        @filter="onFilter"
        option-label="field"
        option-value="value"
        dropdown-icon="la la-search"
        autofocus
        @add="onAddSearch"
        @remove="onRemoveSearch"
      >
        <template v-slot:option="scope">
          <q-item dense v-bind="scope.itemProps" v-on="scope.itemEvents">

            <q-item-section>
              <q-item-label caption>
                Rechercher
                <span class="text-weight-bolder">{{ scope.opt.value}}</span>
                dans
                <span class="text-italic">{{ scope.opt.label }}</span>
              </q-item-label>
            </q-item-section>
          </q-item>
        </template>
        <template v-slot:selected-item="scope">
          <q-chip
            dense size="xs" @remove="scope.removeAtIndex(scope.index)"
            :tabindex="scope.tabindex"
            color="white"
            text-color="black"
            class="q-ma-xs">
            <q-btn-group dense stretch flat>
              <q-btn size="sm" dense color="primary" :label="scope.opt.label"
                     @click="scope.removeAtIndex(scope.index)"/>
              <q-btn size="sm" dense outline text-color="black">
                <div class="row items-center no-wrap">
                  <div class="text-center">
                    <template v-if="Array.isArray(scope.opt.value)">
                      <template v-for="(item, index) in scope.opt.value">
                        {{ item }}&nbsp;
                        <span :key="index" class="text-grey-8 text-lowercase">
                            {{ index !== scope.opt.value.length -1 ? ' ou ' : ''}}
                          </span>
                      </template>
                    </template>
                    <template v-else>
                      {{scope.opt.value }}
                    </template>
                  </div>
                  <q-icon class="q-pa-none q-ma-none" right name="la la-times"
                          @click="scope.removeAtIndex(scope.index)">
                    <q-tooltip>
                      Effacer ce filtre
                    </q-tooltip>
                  </q-icon>
                </div>
              </q-btn>
            </q-btn-group>
          </q-chip>
        </template>
      </q-select>
    </div>
  </div>
</template>

<script>
  import FilterLine from "components/datatables/FilterLine";
  import get from 'lodash/get'

  export default {
    name: 'SearchPanel',
    components: {FilterLine},
    model: {
      prop: 'value',
      event: 'input',
    },
    props: {
      value: {
        type: [Array, String, Object],
      },
      columns: {
        type: Array,
      },
    },
    data() {
      return {
        options: [],
        searchOptions: [],
        filteredSearchOptions: [],
        filterOptions: [],
        search: [],
        filters: [
          {
            type: 'operator',
            value: '',
            field: null,
            operand: {label: 'Et', value: 'and'},
            children: [],
          }
        ]
      }
    },

    methods: {
      onReset() {
        this.filters.splice(0, this.filters.length,
          {
            type: 'operator',
            value: '',
            field: null,
            operand: {label: 'Et', value: 'and'},
            children: [],
          })
        return this.$emit('input', {type: 'operator', operand: 'and', value: []})
      },

      onSearch() {
        let search = this.buildFilter(this.filters);
        if (search){
          const payload = JSON.parse(JSON.stringify(search[0]))
          return this.$emit('input', payload)
        }
      },

      buildFilter(filters) {
        if (get(filters, 'length', 0) > 0) {
          let search = []
          console.log('filters',filters)
          filters.forEach(x => {
            if (x.type === 'condition') {
              let value = get(x, 'value')
              if (get(x, 'field.type') === 'boolean')
                value = !!get(x, 'value')
              search.push({
                type: x.type,
                value,
                field: get(x, 'field.name'),
                operand: get(x, 'operand.value'),
              })
            } else if (x.type === 'operator') {
              let value = this.buildFilter(x.children)
              if (value) {
                search.push({
                  type: x.type,
                  value,
                  operand: get(x, 'operand.value'),
                })
              }
            }
          })
          return search
        }
        return null
      },

      onFilter(val, update, abort) {
        if (val.length < 1) {
          abort()
          return
        }
        update(() => {
          const needle = val
          if (!_.isObject(needle)) {
            this.filteredSearchOptions = []
            this.searchOptions.forEach(v => {
              this.filteredSearchOptions.push({
                id: v.id,
                field: v.id,
                label: v.label,
                operand: v.operand,
                value: needle,
                type: v.type,
              })
            })
          } else {
          }
        })
      },

      onAddSearch(details) {
        let search = [...this.search, details.value]
        let filters = this.buildSearchFilters(search)
        return this.$emit('input', {type: 'operator', operand: 'and', value: filters})
      },

      onRemoveSearch(details) {
        let search = this.search.filter((value, key) => key !== details.index)
        let filters = this.buildSearchFilters(search)
        return this.$emit('input', {type: 'operator', operand: 'and', value: filters})
      },

      buildSearchFilters(search) {
        let filters = []
        if (search.length) {
          search.forEach(x => {
            filters.push({
              type: x.type,
              value: x.value,
              field: x.field,
              operand: x.operand,
            })
          })
          return filters
        }
        return [];
      },

    },

    computed: {
      searcheableColumns() {
        return this.columns.filter(x => x.searchable)
      },
    },

    watch: {
      value: {
        handler: function (newValue, oldValue) {
        },
        deep: true,
        immediate: true,
      },
    },

    mounted() {
      if (this.searcheableColumns) {
        this.searchOptions = this.searcheableColumns.map(v => {
          return {
            id: v.name,
            field: v.name,
            label: v.label,
            operand: 'contains',
            value: null,
            type: 'condition',
          }
        })
      }
    },
  }
</script>
